#include "lcd.h"

#include <avr/io.h>
#include <util/delay.h>

int main()
{
lcd_init();

lcd_write("hello");

while(1) {;;}  // main function on avr shall never return
return 0;
}

void lcd_enab(void);

void lcd_enab(void) {
  PORTD |= 0x10;	//0001 0000
  _delay_us(40);
  PORTD = 0x00;
}



void lcd_init(void) {
  // lcd init
  DDRD = 0xFF;
  PORTD = 0x00;
  _delay_ms(41); // Wait more than 40ms after VDD is stable

// ENABLE 4BIT MODE, see data sheet page 41
  PORTD |= 0x03;  
  lcd_enab();
  _delay_ms(2)   // Wait more than 1.6ms after first command
  PORTD |= 0x03;
  lcd_enab();
  PORTD |= 0x03;
  lcd_enab();
  PORTD |= 0x02;	//0000 0010	
  lcd_enab();

// function set
  PORTD |= 0x02;
  lcd_enab();
  PORTD |= 0x09;	//0000 1001
  lcd_enab();

// bias
  PORTD |= 0x01; 
  lcd_enab();
  PORTD |= 0x04;	// was 0000 0101, CHANGED TO 0000 0100 
  lcd_enab();

// contrast
  PORTD |= 0x07; 	//0000 0111
  lcd_enab();
  PORTD |= 0x08;        // was 0000 0010, CHANGED TO 0000 1000
  lcd_enab();

// power control
  PORTD |= 0x05; 
  lcd_enab();
  PORTD |= 0x05; 
  lcd_enab();

// follower control
  PORTD |= 0x06; 
  lcd_enab();
  PORTD |= 0x0D;       // was 0000 1110, CHANGED TO 0000 1101
  lcd_enab();

// display on
  PORTD |= 0x00; 
  lcd_enab();
  PORTD |= 0x0F; //configure D4-D7 as output
  lcd_enab();

// clear display
  PORTD |= 0x00; 
  lcd_enab();
  PORTD |= 0x01; 
  lcd_enab();
  _delay_ms(2);

// lcd init end
}



void lcd_clear(void) {
  PORTD |= 0x00; 
  lcd_enab();
  PORTD |= 0x01; 
  lcd_enab();
  _delay_ms(2);
}



/* DUE TO DIFFERENT DDRAM ADDRESSES THIS FUNCTION HAS TO BE CHANGED, see data sheet pages 19 and 20
void lcd_goto_xy(uint8_t x, uint8_t y) {
  PORTD |= y | 0x08; 
  lcd_enab();
  PORTD |= x; 
  lcd_enab();  
}
*/



void lcd_putc(char c) {
  PORTD |= ((c>>4) | 0x40); //right shift >> 4bits
  lcd_enab();
  PORTD |= ((c&0x0F) | 0x40); //& bitwise OR
  lcd_enab();
}


void lcd_write(const char *s) {
  while (*s) {
    lcd_putc(*s);
    s++;
  }
}

